package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */
 
 /**
 * IForm tags objects which can be used as a model for certain
 * widgets (e.g. subclasses of ULCFormComponents).
 * The interface doesn't define any methods because all communication
 * between widget and Form might take place within the UI server (like the RowModel).
 * The only requirement is that objects implementing IForm must have a corresponding
 * object in the UI server which implements the IFormModel interface.
 *
 * @see ULCFormModel
 */
public interface IForm extends ISharedProxy {
/**
 * Add the specified attribute to the list of attributes that will be uploaded to the
 * UI even if not requested by the UI when a row is uploaded for the first time. 
 *
 *
 * @param 	attributeName	the <code>String</code> attributeName 
 */
void addPreloadAttribute(String attributeName);
}
