package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */

/**
 * IItemListOwner tags objects which can own an ItemList. The interface is used
 * by itemlists to access information from the widgets using it.
 *
 * @see ULCItemListAbstract
 */
public interface IItemListOwner extends IModelOwner{
/**
 * compute and answer the columns that should be uploaded completely every time
 * the UI gets the initial rows from the itemlist. If a widget returns a non-empty
 * array, the complete table will be uploaded, complete with the attributes returned
 * by computePreloadedAttributes(). In effect, the array answered by this method modifies
 * the prefetch attribute of itemlists / tablemodels
 *
 */
public String[] computePreloadedColumns();
}
