package com.ibm.ulc.application;

/**
 * The IRowAdapter is used to get and set data from the domain models.
 */
public interface IRowAdapter {
/**
 * Answer the attributeName value of the specified object.
 *
 * @param attributeName 	String	The attribute at which the value is requested
 * @param object			Object	The object whose value at the above attribute
 *									is asked for.
 */
public Object getValue(String attributeName, Object object);
/**
 * Set the attributeName value of the object to the specified value.
 *
 * @param attributeName 	String	The attribute
 * @param value				Object	The value to which the above attribute
 *									is being set.
 * @param object			Object	The object whose value at the above attribute
 *									is being set.
 */
public void setValue(String attributeName, Object value, Object object);
}
