package com.ibm.ulc.application;

/*
 * Copyright (c) 1999 Object Technology International Inc.
 */

/**
 * IScaleableGraphicsProducer tags objects which can be used in conjunction with a 
 * UlcGraphicsPane and can optionally zoom their content pane.
 *
 * @see ULCGraphicsPane
 * @see ULCGraphics
 * @see IGraphicsProducer
 */
public interface IScaleableGraphicsProducer extends IGraphicsProducer {
/**
 * The UI widget has been resized zoom the contents to the new size.
 *
 * @see ULCGraphicsPane
 * @see ULCGraphics
 * @see IGraphicsProducer
 */
public void zoom(int x, int y, int width, int height);
}
