package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */

/**
 * This interface is used in order to listen for changes in 
 * the current value (examples ULCField, ULCSlider).
 * The <code>valueChanged(ULCValueChangedEvent)</code> must be implemented to
 * react on the changed value.
 *
 * 
 * @see ULCField#addValueChangedListener(IValueChangedListener)
 *		
 */
public interface IValueChangedListener extends IChangedListener {
/**
 * A value has changed in the widget, do any processing necessary.
 */

void valueChanged(ULCValueChangedEvent e);
}
