package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */

/**
 * Convenience class for creating a horizontal Box.
 */
public class ULCHBox extends ULCBox {
/**
 * Constructs a horizontal box with the default gap.
 */
public ULCHBox() {
	super(false);
}
/**
 * Constructs a horizontal box with the given gap.
 * 
 * @param gap The integer gap to be used between each column.
 */
public ULCHBox(int gap) {
	super(false, gap);
}
/**
 * Constructs a horizontal box with the default gap.
 * If <code>radioGroup</code> is true, all subsequently added ULCRadioButtons
 * will have coordinated radio button behavior.
 * Note: if a Button is a member of a ButtonGroup you can't reset its state to false!
 * You have to set another Button's state to true.
 *
 * @param	radioGroup
 *			The boolean value which if true enables radioGroup behavior.
 */
public ULCHBox(boolean radioGroup) {
	super(false, radioGroup);
}
}
