package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */
import com.ibm.ulc.util.Anything;

/**
 * Internal class for testing new widgets.
 */
class ULCTest extends ULCComponent {
	/**
	 * @serial
	 */
	String fClassName = null;
	public ULCTest(String className) {
		fClassName= className;
	}
	public ULCTest(String className, String label) {
		super(label);
		fClassName= className;
	}
/**
 * Save the state of this object on the supplied Anything.
 * Every ULCProxy object that needs to send state to the UI must 
 * override this method to save its state in the Anything and then
 * call the super class implementation.
 *
 * @param a	Anything	The object into which my state should be saved.
 */
protected void saveState(Anything a) {
	super.saveState(a);
	if (fClassName != null)
		a.put("className", fClassName);
}
}
