package com.ibm.ulc.application;

/*
 * Copyright (c) 1999-2000 Object Technology International Inc.
 */
public abstract class ULCTrigger extends ULCProxy implements ITrigger {
/**
 * ULCTriggerAbstract constructor comment.
 */
public ULCTrigger() {
	super();
}
/**
 * ULCTriggerAbstract constructor comment.
 * @param context com.ibm.ulc.application.ULCContext
 */
public ULCTrigger(ULCContext context) {
	super(context);
}
/**
 * Add a ULCProxy to my list of children.
 */
public void add(ULCProxy proxy) {
	internalAdd(proxy);
}
/**
 * Remove a ULCProxy from my list of children.
 */
public void remove(ULCProxy proxy) {
	internalRemove(proxy);
}
/**
 * The trigger has been reset. Perform any action required to restore the state of the widgets.
 *
 * @see ULCBlockInputTrigger
 */
public void reset() {
	sendUI("reset");
}
/**
 * The trigger has been activated. Perform any action required to mark the widgets as triggerred.
 *
 * @see ULCBlockInputTrigger
 */
public void trigger() {
	sendUI("trigger");
}
}
