package com.ibm.ulc.application;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */

/**
 * Convenience class for for creating a vertical Box.
 */
public class ULCVBox extends ULCBox {
/**
 * Constructs a vertical box with the default gap.
 */
public ULCVBox() {
	super(true);
}
/**
 * Constructs a vertical box with the given gap.
 *
 * @param gap The integer gap to be used between each row.
 */
public ULCVBox(int gap) {
	super(true, gap);
}
/**
 * Constructs a vertical box withe the default gap.
 * If <code>radioGroup</code> is true, all subsequently added ULCRadioButtons
 * will have coordinated radio button behavior.
 * Note: if a Button is a member of a ButtonGroup you can't reset its state to false!
 * You have to set another Button's state to true.
 *
 * @param	radioGroup
 *			The boolean value which if true enables radioGroup behavior.
 */
public ULCVBox(boolean withRadioBehavior) {
	super(true, withRadioBehavior);
}
}
