package com.ibm.ulc.comm;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */
import com.ibm.ulc.comm.Request;

/**
 * Wraps a Connection.close call as a request.
 */
public class CloseRequest extends Request {
	/**
	 * @serial
	 */
	private UlcConnection fConnection = null;
	/**
	 * @serial
	 */
	private UlcTransportException fException = null;
public CloseRequest(UlcConnection connection, UlcTransportException ex) {
	fConnection= connection;
	fException= ex;
}
/**
 * dispatch method comment.
 */
public void dispatch() {
	if (fConnection != null) {
		UlcConnection c = fConnection;
		fConnection = null;
		c.close(fException);
	}
}
}
