package com.ibm.ulc.corba;

import java.io.*;
import org.omg.CORBA.*;
import com.ibm.ulc.util.*;
import com.ibm.ulc.comm.*;

import com.ibm.ulc.corba.generated.*;

public class TestClient {
	static UlcCorbaObject fgClient1= null;
	static UlcCorbaObject fgClient2= null;
/**
 * TestClient constructor comment.
 */
public TestClient() {
	super();
}
public static void createConnection(String remFactoryIOR) {
/*	String urlString= "iiop://localhost:6666/test#" + remFactoryIOR;
	ORBConnection orbConn=
		new ORBConnection(urlString,fConnectionId,fClientData,
						  fReqProc,fDispose,fRegistry);
*/
/*	CorbaUrlConnection corbaConn= new CorbaUrlConnection();
	String urlString= "iiop://localhost:6666/test#" + remFactoryIOR;
	corbaConn.setUrlString(urlString);
	ORBConnection orbConn= new ORBConnection(corbaConn,fConnectionId,fClientData,
									fReqProc,fDispose,fRegistry);
*/
}
public static void createConnectionOld(String remFactoryIOR) {
	// initialize
	ORB orb= ORB.init();
	UlcCorbaServantFactory factory= null;
	UlcCorbaServant servant= null;
	
	// create client of remote factory from IOR
	try {
		org.omg.CORBA.Object objRef= orb.string_to_object(remFactoryIOR);
		factory= UlcCorbaServantFactoryHelper.narrow(objRef);
	}
	catch (org.omg.CORBA.SystemException ex) {
		System.out.println("Exception during narrow (factory)" + ex.toString());
		ex.printStackTrace();
		System.exit(1);
	}
	
	// create local servant
	String servantIOR= null;
	try {
		servant= new UlcCorbaServant();
		servant.setApplicationName("TestClient.servant");
		orb.connect(servant);
		servantIOR= orb.object_to_string(servant);
	}
	catch (org.omg.CORBA.SystemException ex) {
		System.out.println("Exception during ULC servant creation" + ex.toString());
		ex.printStackTrace();
		System.exit(1);
	}
	System.out.println("TestClient.createClient(). servantIOR=" + servantIOR);
		
	// create client
	try {
		// create remote servant and get its IOR
		String remServantIOR= factory.createServant("haha",servantIOR);
		if (remServantIOR == null || remServantIOR.equals("")) {
			System.out.println("TestClient.createClient(). received null IOR from factory.create!");
			return;
		}
		System.out.println("TestClient.createClient(). remServantIOR=" + remServantIOR);
		org.omg.CORBA.Object objRef= orb.string_to_object(remServantIOR);
		fgClient1= UlcCorbaObjectHelper.narrow(objRef);
	}
	catch (org.omg.CORBA.SystemException ex) {
		System.out.println("TestClient.createClient(). Exception during client creation" + ex.toString());
		ex.printStackTrace();
		System.exit(1);
	}
	
//	servant.setConnection();

}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public static void main(String args[]) {

	// initialize
	com.ibm.ulc.comm.UlcConnection.fgDebug= true;
	com.ibm.ulc.comm.UlcTransport.fgDebug= true;
		
	// get ior from URL
	String iorString= null;
/*		iorString= com.ibm.ulc.comm.Connection.getFileFromUrlString(urlString);
		if (iorString.indexOf("/") == 0)
			iorString= iorString.substring(1);
		System.out.println("CorbaUI. IOR: " + iorString);
		if (!iorString.startsWith("IOR:")) {
			BufferedReader br = null;
			try {
				br = new BufferedReader(new FileReader(new File(iorString)));
				iorString= br.readLine();
				br.close();
			}
			catch(IOException fe) {
				System.out.println("Exception raised during opening of file " + iorString + fe.toString()); 
				System.exit(1); 
			}
			System.out.println("CorbaUI. IOR from file: " + iorString);
		}
*/
/*	BufferedReader br= null;
	iorString= "CorbaUlc.ior";
	try {
		br= new BufferedReader(new FileReader(new File(iorString)));
		iorString= br.readLine();
		br.close();
	}
	catch(IOException fe) {
		System.out.println("Exception raised during opening of file " + iorString + fe.toString()); 
		System.exit(1); 
	}
	System.out.println("UlcCorba.TestClient. IOR from file: " + iorString);
*/
	iorString= "IOR:000000000000001f49444c3a556c63436f72626153657276616e74466163746f72793a312e300000000000010000000000000054000100000000000f3139322e3136382e31332e313535000004500000000000343a5c3139322e3136382e31332e3135353a313130343a303a3a4946523a556c63436f72626153657276616e74466163746f727900";
	// build connection
	createConnectionOld(iorString);

	// test
	Anything a= new Anything();
	a.put("corbaDebug","outputOn");
	sendAny(a);
	a= new Anything();
	a.put("corbaDebug","echoOn");
	sendAny(a);
	a= new Anything();
	a.put("host","blaHost");
	a.put("port",69);
	sendAny(a);
	Anything a1= new Anything();
	a1.put("corbaDebug","echoOff");
	sendAny(a1);
	ORBRequest r= new ORBRequest(null,Common.FACTORY_ID,"corbaTest",a);
	sendAny(r.getData());
	
}
static public void sendAny(Anything a) {
	ByteArrayOutputStream os= new ByteArrayOutputStream();
	a.write(os,new AnythingWriter2());
	fgClient1.sendAnyBytes(os.toByteArray());
}
}
