package com.ibm.ulc.corba;

/*
 * Copyright (c) 1998 Object Technology International Inc.
 */
import java.util.*;
import java.io.*;
import java.net.*;
import org.omg.CORBA.*;
import com.ibm.ulc.comm.*;
import com.ibm.ulc.util.*;
import com.ibm.ulc.base.IDefaults;
import com.ibm.ulc.corba.generated.*;


/**
 * An implemention for ULC transports using CORBA.
 *
 * @see UlcTransport
 */
public class UlcCorbaTransport extends UlcCorbaBasedTransport {
/**
 * UlcCorbaTransport constructor.
 */
public UlcCorbaTransport() {
	super();
}
/**
 * UlcCorbaTransport constructor.
 * Will use the passed in Corba client object.
 * @param sender com.ibm.ulc.corba.UlcCorbaObject
 * @param receiver com.ibm.ulc.corba.UlcCorbaServant
 * @param receiverIOR java.lang.String
 */
public UlcCorbaTransport(UlcCorbaObject sender, UlcCorbaServant receiver, String receiverIOR) {
	super(sender, receiver, receiverIOR);
}
/**
 * UlcCorbaTransport constructor.
 * Will use the passed in URL to create a connection to a Corba servant object.
 * @param urlString java.lang.String
 */
public UlcCorbaTransport(String urlString) {
	super(urlString);
}
}
