package com.ibm.ulc.examples.ManagementStructure;

/**
 * (c) Object Technology International 1997,1998.
 */

 import com.ibm.ulc.application.*;
/**
 * This class has been introduced in order to test a new feature of the
 * ULCTree: You can dynamically set the treeModel of a tree to a new
 * treeModel. This means exchanging the data-source of a tree in a
 * dynamic manner.
 *
 * @see ULCAbstractTree#setTreeModel
 * @see ManagementStructureAdapter#getRoot()
 */
public class AnotherMgmtStructAdapter extends ManagementStructureAdapter {
/**
 * Create a new TreeModel for the given editor.
 */
public AnotherMgmtStructAdapter(ManagementStructureEditor editor) {
	super(editor);
}
/**
 * Answer the root node of the receiver.
 * As a test, we use a different root for this mode, so
 * that the change of the treeModel is clearly visible
 * in the UI.
 */
public Object getRoot() {
	return fBiggestBoss.getChildren().elementAt(0);
}
}
