package com.ibm.ulc.examples.ManagementStructure;

import com.ibm.ulc.application.*;

/**
 * This class is used for acting on the callback which comes
 * when an employee needs to be 'deleted' from the organization
 * tree.
 * Note that it is possible to do without this class, and to use
 * an inner class instead.
 *
 * @see ManagementStructureEditor#createDeleteEmployeeButton()
 *
 */
public class DeleteEmployeeAction extends ManagementStructureAction implements IActionListener {
/**
 * Constructing the receiver for the given editor
 */
public DeleteEmployeeAction(ManagementStructureEditor editor) {
	super(editor);
}
/**
 * Pass this information back to the editor, so
 * that it can do the needful.
 */
public void actionPerformed(ULCActionEvent e) {
	fEditor.deleteSelectedEmployee();
}
}
