package com.ibm.ulc.examples.carRental.model;

/**
 * Interface of objects that can be used as comparaison policies.
 *
 * @author: Markus Marzetta (CS-ZRH)
 */
public interface Comparator {
/**
 * Compares its two arguments for order.  Returns a negative integer,
 * zero, or a positive integer as the first argument is less than, equal
 * to, or greater than the second.<p>
 *
 * @return a negative integer, zero, or a positive integer as the
 * 	       first argument is less than, equal to, or greater than the
 *	       second. 
 * @throws ClassCastException if the arguments' types prevent them from
 * 	       being compared by this Comparator.
 */
int compare(Object o1, Object o2);
}
