package com.ibm.ulc.examples.carRental.model;

import java.util.Date;

/**
 * Instances represent guarantees offered by the one who makes the reservation
 * (credit card details)
 *
 * @author: Markus Marzetta (CS-ZRH)
 */
public class Guarantee extends CarRentalObject {
	/**
	 * The card company.
	 */
	 protected CardCompany fCardCompany= null;
	 
	/**
	 * The card number.
	 */
	 protected String fCardNumber= "";

	/**
	 * The expiry date for the card.
	 */
	 protected Date fExpiration= null;
/**
 * Guarantee constructor comment.
 */
public Guarantee() {
	super();
}
/**
 * Gets the cardCompany property (com.ibm.ulc.examples.carRental.model.CardCompany) value.
 * @return The cardCompany property value.
 * @see #setCardCompany
 */
public CardCompany getCardCompany() {
	return fCardCompany;
}
/**
 * Gets the cardNumber property (String) value.
 * @return The cardNumber property value.
 * @see #setCardNumber
 */
public String getCardNumber() {
	return fCardNumber;
}
/**
 * Gets the expiration property (Date) value.
 * @return The expiration property value.
 * @see #setExpiration
 */
public Date getExpiration() {
	return fExpiration;
}
/**
 * Sets the cardCompany property (com.ibm.ulc.examples.carRental.model.CardCompany) value.
 * @param cardCompany The new value for the property.
 * @see #getCardCompany
 */
public void setCardCompany(CardCompany cardCompany) {
	fCardCompany = cardCompany;
}
/**
 * Sets the cardNumber property (String) value.
 * @param cardNumber The new value for the property.
 * @see #getCardNumber
 */
public void setCardNumber(String cardNumber) {
	fCardNumber = cardNumber;
}
/**
 * Sets the expiration property (Date) value.
 * @param expiration The new value for the property.
 * @see #getExpiration
 */
public void setExpiration(Date expiration) {
	fExpiration = expiration;
}
}
