package com.ibm.ulc.examples.carRental.model;

/**
 * Instances represent optional equipment required by the customer.
 *
 * @author: Markus Marzetta (CS-ZRH)
 */
public class OptionsSpec extends CarRentalObject {
	/**
	 * Number of child seats.
	 */
	 protected int fChildSeats= 0;
	
	/**
	 * Mobile phone.
	 */
	 protected boolean fMobile= false;
	
	/**
	 * Navigation (neverlost) system.
	 */
	 protected boolean fNavigation= false;
	
	/**
	 * Loss insurance.
	 */
	 protected boolean fLossIns= false;
	
	/**
	 * Property insurance.
	 */
	 protected boolean fPropertyIns= false;
/**
 * OptionsSpec constructor comment.
 */
public OptionsSpec() {
	super();
}
/**
 * Gets the childSeats property (int) value.
 * @return The childSeats property value.
 * @see #setChildSeats
 */
public int getChildSeats() {
	return fChildSeats;
}
/**
 * Gets the lossIns property (boolean) value.
 * @return The lossIns property value.
 * @see #setLossIns
 */
public boolean getLossIns() {
	return fLossIns;
}
/**
 * Gets the mobile property (boolean) value.
 * @return The mobile property value.
 * @see #setMobile
 */
public boolean getMobile() {
	return fMobile;
}
/**
 * Gets the navigation property (boolean) value.
 * @return The navigation property value.
 * @see #setNavigation
 */
public boolean getNavigation() {
	return fNavigation;
}
/**
 * Gets the propertyIns property (boolean) value.
 * @return The propertyIns property value.
 * @see #setPropertyIns
 */
public boolean getPropertyIns() {
	return fPropertyIns;
}
/**
 * Sets the childSeats property (int) value.
 * @param childSeats The new value for the property.
 * @see #getChildSeats
 */
public void setChildSeats(int childSeats) {
	fChildSeats = childSeats;
}
/**
 * Sets the lossIns property (boolean) value.
 * @param lossIns The new value for the property.
 * @see #getLossIns
 */
public void setLossIns(boolean lossIns) {
	fLossIns = lossIns;
}
/**
 * Sets the mobile property (boolean) value.
 * @param mobile The new value for the property.
 * @see #getMobile
 */
public void setMobile(boolean mobile) {
	fMobile = mobile;
}
/**
 * Sets the navigation property (boolean) value.
 * @param navigation The new value for the property.
 * @see #getNavigation
 */
public void setNavigation(boolean navigation) {
	fNavigation = navigation;
}
/**
 * Sets the propertyIns property (boolean) value.
 * @param propertyIns The new value for the property.
 * @see #getPropertyIns
 */
public void setPropertyIns(boolean propertyIns) {
	fPropertyIns = propertyIns;
}
}
