package com.ibm.ulc.examples.carRental.views;

import com.ibm.ulc.base.*;
import com.ibm.ulc.application.*;

/**
 * The composite used to show the details about the guarantee 
 * for the reservation (credit card).
 * @author: Markus Marzetta (CS-ZRH)
 */

public class GuaranteeForm extends NotebookPageComposite {
	private ULCLabel ivjCreditCardPleaseLabel = null;
	private ULCBox ivjVerticalBox = null;
	private ULCBox ivjBox1 = null;
	private ULCLabel ivjCardCompanyLabel = null;
	private ULCComboBox ivjCardCompanyList = null;
	private ULCField ivjCardExpirationField = null;
	private ULCField ivjCardNumberField = null;
	private ULCLabel ivjCardNumberLabel = null;
	private ULCLabel ivjExpirationLabel = null;
	private ULCLabel ivjFillOutLabel = null;
	private ULCPage ivjHasPricingInfoFalsePage = null;
	private ULCPage ivjHasPricingInfoTruePage = null;
	private ULCPagebook ivjPagebook1 = null;
	private ULCLabel ivjPleaseLabel = null;
	private ULCBox ivjVerticalBox1 = null;
	private FinalPersistentTableModel ivjCardCompanyTableModel = null;
/**
 * GuaranteeForm constructor comment.
 */
public GuaranteeForm() {
	super();
	initialize();
}
/**
 * GuaranteeForm constructor comment.
 * @param usesVajContext com.ibm.ulc.application.IUsesVajContext
 */
public GuaranteeForm(com.ibm.ulc.application.IUsesVajContext usesVajContext) {
	super(usesVajContext);
	initialize();
}
/**
 * connPtoP1SetTarget:  (CardCompanyTableModel.this <--> CardCompanyList.tableModel)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connPtoP1SetTarget() {
	/* Set the target from the source */
	try {
		getCardCompanyList().setTableModel(getCardCompanyTableModel());
		// user code begin {1}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Do the final part initializations here.
 * Creation date: (06.01.00 22:27:49)
 */
protected void finalInitialize() {
	super.finalInitialize();
	getCardCompanyTableModel().setRows(getDataAccessor().getCardCompanies());
}
/**
 * Return the Box1 property value.
 * @return com.ibm.ulc.application.ULCBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCBox getBox1() {
	if (ivjBox1 == null) {
		try {
			ivjBox1 = new com.ibm.ulc.application.ULCBox(4, 2);
			ivjBox1.add(0, 0, getCardCompanyLabel());
			ivjBox1.add(0, 1, getCardNumberLabel());
			ivjBox1.add(1, 0, com.ibm.ulc.base.IDefaults.BOX_EXPAND_CENTER, getCardCompanyList());
			ivjBox1.add(1, 1, com.ibm.ulc.base.IDefaults.BOX_EXPAND_CENTER, getCardNumberField());
			ivjBox1.add(0, 2, getExpirationLabel());
			ivjBox1.add(1, 2, com.ibm.ulc.base.IDefaults.BOX_EXPAND_CENTER, getCardExpirationField());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjBox1;
}
/**
 * Return the CardCompanyLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getCardCompanyLabel() {
	if (ivjCardCompanyLabel == null) {
		try {
			ivjCardCompanyLabel = new com.ibm.ulc.application.ULCLabel("Credit card company");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardCompanyLabel;
}
/**
 * Return the CardCompanyList property value.
 * @return com.ibm.ulc.application.ULCComboBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCComboBox getCardCompanyList() {
	if (ivjCardCompanyList == null) {
		try {
			ivjCardCompanyList = new com.ibm.ulc.application.ULCComboBox();
			ivjCardCompanyList.setFormAttributeName("cardCompanyName");
			ivjCardCompanyList.setAttributeName("name");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardCompanyList;
}
/**
 * Return the CardCompanyTableModel property value.
 * @return com.ibm.ulc.examples.carRental.views.FinalPersistentTableModel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private FinalPersistentTableModel getCardCompanyTableModel() {
	if (ivjCardCompanyTableModel == null) {
		try {
			ivjCardCompanyTableModel = new com.ibm.ulc.examples.carRental.views.FinalPersistentTableModel();
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardCompanyTableModel;
}
/**
 * Return the CardExpirationField property value.
 * @return com.ibm.ulc.application.ULCField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCField getCardExpirationField() {
	if (ivjCardExpirationField == null) {
		try {
			com.ibm.ulc.application.ULCDateValidator ivjLocalDataType1;
			ivjLocalDataType1 = new com.ibm.ulc.application.ULCDateValidator();
			ivjLocalDataType1.setFormatString("MM-yy");
			ivjCardExpirationField = new com.ibm.ulc.application.ULCField();
			ivjCardExpirationField.setFormAttributeName("expiration");
			ivjCardExpirationField.setDataType(ivjLocalDataType1);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardExpirationField;
}
/**
 * Return the CardNumberField property value.
 * @return com.ibm.ulc.application.ULCField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCField getCardNumberField() {
	if (ivjCardNumberField == null) {
		try {
			com.ibm.ulc.application.ULCStringFormatter ivjLocalDataType;
			ivjLocalDataType = new com.ibm.ulc.application.ULCStringFormatter();
			ivjLocalDataType.setMode(ULCStringFormatter.ALL_UPPER_CASE);
			ivjLocalDataType.setMaxLength(20);
			ivjCardNumberField = new com.ibm.ulc.application.ULCField();
			ivjCardNumberField.setFormAttributeName("cardNumber");
			ivjCardNumberField.setDataType(ivjLocalDataType);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardNumberField;
}
/**
 * Return the CardNumberLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getCardNumberLabel() {
	if (ivjCardNumberLabel == null) {
		try {
			ivjCardNumberLabel = new com.ibm.ulc.application.ULCLabel("Card number");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCardNumberLabel;
}
/**
 * Return the CreditCardPleaseLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getCreditCardPleaseLabel() {
	if (ivjCreditCardPleaseLabel == null) {
		try {
			ivjCreditCardPleaseLabel = new com.ibm.ulc.application.ULCLabel("Your credit card, Please!");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjCreditCardPleaseLabel;
}
/**
 * Return the ExpirationLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getExpirationLabel() {
	if (ivjExpirationLabel == null) {
		try {
			ivjExpirationLabel = new com.ibm.ulc.application.ULCLabel("Expiration date (MM-yy)");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjExpirationLabel;
}
/**
 * Return the FillOutLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getFillOutLabel() {
	if (ivjFillOutLabel == null) {
		try {
			ivjFillOutLabel = new com.ibm.ulc.application.ULCLabel("Fill out pickup, return, and car page before");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjFillOutLabel;
}
/**
 * Return the HasPricingInfoFalsePage property value.
 * @return com.ibm.ulc.application.ULCPage
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCPage getHasPricingInfoFalsePage() {
	if (ivjHasPricingInfoFalsePage == null) {
		try {
			ivjHasPricingInfoFalsePage = new com.ibm.ulc.application.ULCPage("false", getVerticalBox1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjHasPricingInfoFalsePage;
}
/**
 * Return the HasPricingInfoTruePage property value.
 * @return com.ibm.ulc.application.ULCPage
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCPage getHasPricingInfoTruePage() {
	if (ivjHasPricingInfoTruePage == null) {
		try {
			ivjHasPricingInfoTruePage = new com.ibm.ulc.application.ULCPage("true", getBox1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjHasPricingInfoTruePage;
}
/**
 * Return the Pagebook1 property value.
 * @return com.ibm.ulc.application.ULCPagebook
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCPagebook getPagebook1() {
	if (ivjPagebook1 == null) {
		try {
			ivjPagebook1 = new com.ibm.ulc.application.ULCPagebook();
			ivjPagebook1.setFormAttributeName("hasPricingInfo");
			ivjPagebook1.addPage(getHasPricingInfoTruePage());
			ivjPagebook1.addPage(getHasPricingInfoFalsePage());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjPagebook1;
}
/**
 * Return the PleaseLabel property value.
 * @return com.ibm.ulc.application.ULCLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCLabel getPleaseLabel() {
	if (ivjPleaseLabel == null) {
		try {
			ivjPleaseLabel = new com.ibm.ulc.application.ULCLabel("Please");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjPleaseLabel;
}
/**
 * Return the Vertical Box property value.
 * @return com.ibm.ulc.application.ULCBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCBox getVerticalBox() {
	if (ivjVerticalBox == null) {
		try {
			ivjVerticalBox = new com.ibm.ulc.application.ULCBox(2, 1);
			ivjVerticalBox.add(0, 0, com.ibm.ulc.base.IDefaults.BOX_LEFT_TOP, getCreditCardPleaseLabel());
			ivjVerticalBox.add(0, 1, com.ibm.ulc.base.IDefaults.BOX_EXPAND_EXPAND, getPagebook1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjVerticalBox;
}
/**
 * Return the Vertical Box1 property value.
 * @return com.ibm.ulc.application.ULCBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private com.ibm.ulc.application.ULCBox getVerticalBox1() {
	if (ivjVerticalBox1 == null) {
		try {
			ivjVerticalBox1 = new com.ibm.ulc.application.ULCBox(2, 1);
			ivjVerticalBox1.add(0, 0, getPleaseLabel());
			ivjVerticalBox1.add(0, 1, getFillOutLabel());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjVerticalBox1;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	connPtoP1SetTarget();
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		// user code begin {2}
		// user code end
		setComponent(getVerticalBox());
		getCardCompanyTableModel();
		initConnections();
		// user code begin {3}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {4}
	finalInitialize();
	// user code end
}
/**
 * Please do not use or rely on this method. It is used by the VAJava test process.
 * It is public only so that the ULCVajContext class can access the method.
 * It can change at any time, or it could be entirely removed in any update 
 * to the VAJava builder. Thank you.
 * @return com.ibm.ulc.application.ULCComponent
 * @param context com.ibm.ulc.application.ULCVajContext
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public static com.ibm.ulc.application.ULCComponent mainTestConstruction(com.ibm.ulc.application.ULCVajContext context) {
	return new GuaranteeForm(context);
}
/**
 * Make the getter available to the package.
 * @return com.ibm.ulc.application.ULCField
 */
ULCField pGetCardExpirationField() {
	return getCardExpirationField();
}
/**
 * Make the getter available to the package.
 * @return com.ibm.ulc.application.ULCField
 */
ULCField pGetCardNumberField() {
	return getCardNumberField();
}
/**
 * Sets the contractSpecFormModel property (com.ibm.ulc.examples.carRental.views.ContractSpecFormModel) value.
 * @param contractSpecFormModel The new value for the property.
 * @see #getContractSpecFormModel
 */
public void setContractSpecFormModel(ContractSpecFormModel contractSpecFormModel) {
	fContractSpecFormModel = contractSpecFormModel;
	//
	getCardCompanyList().setFormModel(contractSpecFormModel);
	getCardNumberField().setFormModel(contractSpecFormModel);
	getCardExpirationField().setFormModel(contractSpecFormModel);
}
/**
 * Set the fonts of the subparts.
 * Creation date: (06.01.00 22:27:49)
 */
protected void setFonts() {
	super.setFonts();
	getCreditCardPleaseLabel().setFont(HUGE_LABEL_FONT);
	//
	getPleaseLabel().setFont(LARGE_LABEL_FONT);
	//
	getCardCompanyLabel().setFont(NORMAL_LABEL_FONT);
	getCardNumberLabel().setFont(NORMAL_LABEL_FONT);
	getExpirationLabel().setFont(NORMAL_LABEL_FONT);
}
/**
 * Set the size of notebooks and pagebooks,
 * which is mandatory!
 *
 * Creation date: (06.01.00 22:27:49)
 */
protected void sizeNoteAndPageBooks() {
	/* Setting the layout parameters with the property sheets
	 * in the composition editor, makes the edit time layout
	 * too poor: we have to set H and W by code
	 */
	getPagebook1().setHeight(368); 
	getPagebook1().setWidth(424);
}
}
