package com.ibm.ulc.test;

/**
 * This type was created in VisualAge.
 */

import com.ibm.ulc.application.*;
abstract class UlxAbstractComposite extends ULCVajComposite {
	protected transient java.beans.PropertyChangeSupport propertyChange;
	private UlxSystem fSystem;
/**
 * UlxViewAbstractComposite constructor comment.
 */
public UlxAbstractComposite() {
	super();
}
/**
 * UlxViewAbstractComposite constructor comment.
 * @param vajContext com.ibm.ulc.varun.ULCVajContext
 */
public UlxAbstractComposite(IUsesVajContext usesVajContext) {
	super(usesVajContext);
	//ulxInitialize(getVajContext());
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(listener);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 * @param propertyName java.lang.String
 * @param oldValue java.lang.Object
 * @param newValue java.lang.Object
 */
public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * Comment
 */
public ULCBlockInputTrigger getBusyTrigger() {
	return getSystem().getBusyTrigger();
}
/**
 * Returns the <code>ULCContext</code> within which the widget is active.
 *
 * @return The <code>ULCContext</code> within which the widget is active.
 */
public ULCContext getContext() {
	return getVajContext();
}
/**
 * Comment
 */
public ULCIcon getGreenIcon() {
return	getSystem().getGreenBall();
}
/**
 * Accessor for the propertyChange field.
 */
protected java.beans.PropertyChangeSupport getPropertyChange() {
	if (propertyChange == null) {
		propertyChange = new java.beans.PropertyChangeSupport(this);
	};
	return propertyChange;
}
/**
 * Comment
 */
public ULCIcon getRedIcon() {
	return getSystem().getRedBall();
}
/**
 * Gets the system property (com.ibm.ulc.test.UlxSystem) value.
 * @return The system property value.
 * @see #setSystem
 */
public UlxSystem getSystem() {
	if (fSystem == null)
		ulxInitialize(getVajContext());
	return fSystem;
}
/**
 * Comment
 */
public ULCIcon getYellowIcon() {
	return getSystem().getYellowBall();
}
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(listener);
}
/**
 * Gets the system property (com.ibm.ulc.test.UlxSystem) value.
 * @return The system property value.
 */
public void setSystem(UlxSystem system) {
	fSystem = system;
}
public void startBatchingRequests() {
	if (fContext != null)
		fContext.startBatchingRequests();
}
public void stopBatchingRequests() {
	if (fContext != null)
		fContext.stopBatchingRequests();
}
/**
 * Gets the system property (com.ibm.ulc.test.UlxSystem) value.
 * @return The system property value.
 * @see #setSystem
 */
void ulxInitialize(ULCVajContext vaContext) {
	if (fSystem == null) {
		try {
			UlxContext context = (UlxContext) vaContext;
			setSystem(context.getSystem());
		}
		catch (Throwable t) {
			Object object = vaContext.getProperty("ulxSystem", null);
			UlxSystem system = null;
			if (object == null) {
				system = new UlxSystem(vaContext);
				vaContext.setProperty("ulxSystem", system);
			}
			else {
				system = (UlxSystem) object;
			}
			setSystem(system);
		}
	}
}
}
