package com.ibm.ulc.test;

/**
 * This class implements some useful collection protocol.
 */
class UlxCollection {
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static Object[] add(Object[] answer, Object[] objects, Object object) {
	if (objects.length == 0) {
		answer[0] = object;
	}
	else {
		System.arraycopy(objects, 0, answer, 0, objects.length);
		answer[answer.length - 1] = object;
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static Object[] addUnique(Object[] answer, Object[] objects, Object object) {
	for (int i = 0; i < objects.length; i++) {
		if (objects[i].equals(object))
			return objects;
	}
	return add(answer, objects, object);
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static void addUnique(java.util.Vector into, Object[] objects) {
	for (int i = 0; i < objects.length; i++) {
		if (!into.contains(objects[i]))
			into.addElement(objects[i]);
	}
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static boolean contains(Object[] objects, Object object) {
	if (objects.length == 0)
		return false;
	for (int i = 0; i < objects.length; i++) {
		if (objects[i].equals(object))
			return true;
	}
	return false;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static boolean containsAll(Object[] objects, Object[] contained) {
	boolean answer = true;
	for (int i = 0; i < contained.length; i++) {
		boolean jAnswer = false;
		for (int j = 0; j < objects.length; j++) {
			if (contained[i].equals(objects[j])) {
				jAnswer = true;
				break;
			}
		}
		answer = jAnswer;
		if (!answer)
			break;
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static Object[] copyToArray(java.util.Vector vector) {
	Object[] answer = new Object[vector.size()];
	for (int i = 0; i < vector.size(); i++) {
		answer[i] = vector.elementAt(i);
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static java.util.Vector copyToVector(int[] array) {
	java.util.Vector answer = new java.util.Vector(array.length);
	for (int i = 0; i < array.length; i++) {
		answer.addElement(new Integer(array[i]));
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static java.util.Vector copyToVector(Object[] array) {
	java.util.Vector answer = new java.util.Vector(array.length);
	for (int i = 0; i < array.length; i++) {
		answer.addElement(array[i]);
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static int indexOf(Object[] objects, Object object) {
	int answer = -1;
	for (int i = 0; i < objects.length; i++) {
		if (objects[i].equals(object)) {
			answer = i;
			break;
		}
	}
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static Object[] remove(Object[] result, Object[] objects, Object object) {
	int index = -1;
	for (int i = 0; i < objects.length; i++) {
		if (objects[i] == object) {
			index = i;
			break;
		}
	}
	Object[] answer = result;
	if (index > -1) {
		int newLength = objects.length - 1;
		if (newLength > 0) {
			if (index > 0)
				System.arraycopy(objects, 0, answer, 0, index);
			if (index < answer.length)
				System.arraycopy(objects, index + 1, answer, index, (answer.length - index));
		} else {
			answer = new Object[0];
		}
	} else
		answer = objects;
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static Object[] remove(Object[] objects, Object object) {
	int index = -1;
	for (int i = 0; i < objects.length; i++) {
		if (objects[i] == object) {
			index = i;
			break;
		}
	}
	Object[] answer = null;
	if (index > -1) {
		int newLength = objects.length - 1;
		if (newLength > 0) {
			answer = new Object[newLength];
			if (index > 0)
				System.arraycopy(objects, 0, answer, 0, index);
			if (index < answer.length)
				System.arraycopy(objects, index + 1, answer, index, (answer.length - index));
		}
		else {
			answer = new Object[0];
		}
	}
	else
		answer = objects;
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static String[] remove(String[] objects, String object) {
	int index = -1;
	for (int i = 0; i < objects.length; i++) {
		if (objects[i] == object) {
			index = i;
			break;
		}
	}
	String[] answer = null;
	if (index > -1) {
		int newLength = objects.length - 1;
		if (newLength > 0) {
			answer = new String[newLength];
			if (index > 0)
				System.arraycopy(objects, 0, answer, 0, index);
			if (index < answer.length)
				System.arraycopy(objects, index + 1, answer, index, (answer.length - index));
		}
		else {
			answer = new String[0];
		}
	}
	else
		answer = objects;
	return answer;
}
/**
 * Answer true if all elements in @left are also included in @right. This method ignores ordering of elements.
 */
static boolean sameContents(Object[] left, Object[] right) {
	boolean answer = left.length == right.length;
	if (!answer)
		return false;
	for (int i = 0; i < left.length; i++) {
		boolean jAnswer = false;
		for (int j = 0; j < right.length; j++) {
			if (left[i].equals(right[j])) {
				jAnswer = true;
				break;
			}
		}
		answer = jAnswer;
		if (!answer)
			break;
	}
	return answer;
}
}
