package com.ibm.ulc.test;

import com.ibm.ulc.application.*;
import com.ibm.ulc.testsample.UlxBusinessController;

public abstract class UlxTestedViewAbstract extends UlxAbstractComposite {
	protected UlxAbstractTestComposite fTestComposite = null;
/**
 * UlxTestViewAbstract constructor comment.
 */
public UlxTestedViewAbstract() {
	super();
}
/**
 * UlxAbstractTestComposite constructor comment.
 * @param vajContext com.ibm.ulc.varun.IUsesVajContext
 */
public UlxTestedViewAbstract(IUsesVajContext usesVajContext) {
	super(usesVajContext);
}
abstract public String getComponentLabel();
public UlxBusinessController getController() {
	return getTestComposite().getController();
}
public UlxAbstractTestComposite getTestComposite() {
	return fTestComposite;
}
public UlxTestData getTestData() {
	return getTestComposite().getTestData();
}
public abstract ULCComponent getTestedComponent();
/**
 * getTestedComponent method comment.
 */
public com.ibm.ulc.application.ULCProxy getTestedProxy() {
	return getTestedComponent();
}
public void setTestComposite(UlxAbstractTestComposite composite) {
	fTestComposite = composite;
}
/**
 * Answer the test categories covered by the receiver
 *
 * 
 */
static public String[] testCategories() {
	return new String[] {"uncategorized"};
}
/**
 * Answer the names of the API tested in this component.
 *
 * The answer contains the names of the methods tested.
 */
static public String[] testedAPI() {
	return new String[0];
}
/**
 * Answer the names of the ULC classes tested in this component.
 *
 * Unless the classse tested are defined in <code>com.ibm.ulc.application</code>, the
 * class names must be fully specified. This information is optional if @testedPRs 
 * is specified.
 */
static public String[] testedClasses() {
	return new String[] {};
}
/**
 * Answer the String to be displayed in the receiver's notebook tab.
 *
 * Some test suites will include multiple tests in one notebook. This method
 * allows for specific titles. If subclasses do not reimplement this method, the
 * receiver's class name is answered.
 */
static public String testPageTabString() {
	if (testedClasses().length > 0)
		return testedClasses()[0];
	else
		return "N/A";
}
}
