package com.ibm.ulc.test.cases;

import java.util.*;
import com.ibm.ulc.application.IPropertyChanger;
public class UlxSimplePerson implements IPropertyChanger {
	protected transient java.beans.PropertyChangeSupport propertyChange;
	private java.lang.String fieldFirstName = new String();
	private java.lang.String fieldLastName = new String();
	private int fieldIdentifier = -1;
	private int fieldParentIdentifier = -1;
	private UlxSimplePerson fieldParent = null;
	public static int fgLastFieldIdentifier = 0;
	private java.util.Vector fieldChildren = new Vector();
/**
 * Comment
 * @param firstName java.lang.String
 * @param lastName java.lang.String
 * @param identifier int
 * @param parentIdentifier int
 */
public UlxSimplePerson(String firstName, String lastName, int identifier, UlxSimplePerson parent) {
	this(firstName, lastName, identifier, parent, -1);
}
/**
 * Comment
 * @param firstName java.lang.String
 * @param lastName java.lang.String
 * @param identifier int
 * @param parentIdentifier int
 */
public UlxSimplePerson(String firstName, String lastName, int identifier, UlxSimplePerson parent, int childIndex) {
	super();
	setParent(parent, childIndex);
	setFirstName(firstName);
	setLastName(lastName);
	setIdentifier(identifier);
}
/**
 * Comment
 * @param firstName java.lang.String
 * @param lastName java.lang.String
 * @param identifier int
 * @param parentIdentifier int
 */
public UlxSimplePerson(String firstName, String lastName, UlxSimplePerson parent) {
	this(firstName, lastName, fgLastFieldIdentifier++, parent, -1);
}
/**
 * Comment
 * @param firstName java.lang.String
 * @param lastName java.lang.String
 * @param identifier int
 * @param parentIdentifier int
 */
public UlxSimplePerson(String firstName, String lastName, UlxSimplePerson parent, int childIndex) {
	this(firstName, lastName, fgLastFieldIdentifier++, parent, childIndex);
}
public void addChild(UlxSimplePerson child) {
	addChild(child, -1);
}
public void addChild(UlxSimplePerson child, int childIndex) {
	try {
		getChildren().add(childIndex, child);
	} catch (ArrayIndexOutOfBoundsException e) {
		getChildren().add(child); //at end}
	}
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(listener);
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(java.lang.String propertyName, java.beans.PropertyChangeListener listener) {
	getPropertyChange().addPropertyChangeListener(propertyName, listener);
}
public void deleteChild(UlxSimplePerson child) {
	getChildren().remove(child);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(java.beans.PropertyChangeEvent evt) {
	getPropertyChange().firePropertyChange(evt);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(java.lang.String propertyName, int oldValue, int newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(java.lang.String propertyName, java.lang.Object oldValue, java.lang.Object newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(java.lang.String propertyName, boolean oldValue, boolean newValue) {
	getPropertyChange().firePropertyChange(propertyName, oldValue, newValue);
}
/**
 * Gets the children property (java.util.Vector) value.
 * @return The children property value.
 * @see #setChildren
 */
public java.util.Vector getChildren() {
	return fieldChildren;
}
/**
 * Gets the fFirstName property (java.lang.String) value.
 * @return The fFirstName property value.
 * @see #setFFirstName
 */
public java.lang.String getFirstName() {
	return fieldFirstName;
}
/**
 * Gets the fFirstName property (java.lang.String) value.
 * @return The fFirstName property value.
 * @see #setFFirstName
 */
public String getFullName() {
	return getFirstName() + " " + getLastName();
}
/**
 * Gets the identifier property (int) value.
 * @return The identifier property value.
 * @see #setIdentifier
 */
public int getIdentifier() {
	return fieldIdentifier;
}
/**
 * Gets the lastName property (java.lang.String) value.
 * @return The lastName property value.
 * @see #setLastName
 */
public java.lang.String getLastName() {
	return fieldLastName;
}
/**
 * Gets the parent property (com.ibm.ulc.test.cases.UlxSimplePerson) value.
 * @return The parent property value.
 * @see #setParent
 */
public UlxSimplePerson getParent() {
	return fieldParent;
}
/**
 * Gets the parentIdentifier property (int) value.
 * @return The parentIdentifier property value.
 * @see #setParentIdentifier
 */
public int getParentIdentifier() {
	return fieldParentIdentifier;
}
/**
 * Accessor for the propertyChange field.
 */
protected java.beans.PropertyChangeSupport getPropertyChange() {
	if (propertyChange == null) {
		propertyChange = new java.beans.PropertyChangeSupport(this);
	};
	return propertyChange;
}
public java.util.Vector getSpecialChildren() {
	return getChildren();
}
/**
 * The hasListeners method was generated to support the propertyChange field.
 */
public synchronized boolean hasListeners(java.lang.String propertyName) {
	return getPropertyChange().hasListeners(propertyName);
}
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(listener);
}
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(java.lang.String propertyName, java.beans.PropertyChangeListener listener) {
	getPropertyChange().removePropertyChangeListener(propertyName, listener);
}
/**
 * Sets the children property (java.util.Vector) value.
 * @param children The new value for the property.
 * @see #getChildren
 */
public void setChildren(java.util.Vector children) {
	Vector oldValue = fieldChildren;
	fieldChildren = children;
	firePropertyChange("children", oldValue, children);
}
/**
 * Sets the fFirstName property (java.lang.String) value.
 * @param fFirstName The new value for the property.
 * @see #getFFirstName
 */
public void setFirstName(java.lang.String firstName) {
	String oldValue = fieldFirstName;
	fieldFirstName = firstName;
	firePropertyChange("FirstName", oldValue, firstName);
}
/**
 * Sets the identifier property (int) value.
 * @param identifier The new value for the property.
 * @see #getIdentifier
 */
public void setIdentifier(int identifier) {
	int oldValue = fieldIdentifier;
	fieldIdentifier = identifier;
	firePropertyChange("identifier", new Integer(oldValue), new Integer(identifier));
}
/**
 * Sets the lastName property (java.lang.String) value.
 * @param lastName The new value for the property.
 * @see #getLastName
 */
public void setLastName(java.lang.String lastName) {
	String oldValue = fieldLastName;
	fieldLastName = lastName;
	firePropertyChange("lastName", oldValue, lastName);
}
/**
 * Sets the parent property (com.ibm.ulc.test.cases.UlxSimplePerson) value.
 * @param parent The new value for the property.
 * @see #getParent
 */
public void setParent(UlxSimplePerson parent) {
	UlxSimplePerson oldValue = fieldParent;
	fieldParent = parent;
	firePropertyChange("parent", oldValue, parent);
	if (parent != null) {
		setParentIdentifier(parent.getIdentifier());
		parent.addChild(this);
	} else
		setParentIdentifier(-1);
}
/**
 * Sets the parent property (com.ibm.ulc.test.cases.UlxSimplePerson) value.
 * @param parent The new value for the property.
 * @see #getParent
 */
public void setParent(UlxSimplePerson parent, int childIndex) {
	UlxSimplePerson oldValue = fieldParent;
	fieldParent = parent;
	firePropertyChange("parent", oldValue, parent);
	if (parent != null) {
		setParentIdentifier(parent.getIdentifier());
		parent.addChild(this, childIndex);
	} else
		setParentIdentifier(-1);
}
/**
 * Sets the parentIdentifier property (int) value.
 * @param parentIdentifier The new value for the property.
 * @see #getParentIdentifier
 */
public void setParentIdentifier(int parentIdentifier) {
	int oldValue = fieldParentIdentifier;
	fieldParentIdentifier = parentIdentifier;
	firePropertyChange("parentIdentifier", new Integer(oldValue), new Integer(parentIdentifier));
}
/**
 * Gets the fFirstName property (java.lang.String) value.
 * @return The fFirstName property value.
 * @see #setFFirstName
 */
public String toString() {
	return "(" + getFullName() + ")";
}
}
