package com.ibm.ulc.ui.base;

/*
 * Copyright (c) 1997,1998 Object Technology International Inc.
 */
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.peer.*;

import com.ibm.ulc.util.Anything;
import com.ibm.ulc.util.UlcObject;
import com.ibm.ulc.util.UlcConsole;
import com.ibm.ulc.util.Assert;
import com.ibm.ulc.comm.*;

/**
 * AWTRequest wraps our Requests as AWTEvent.
 * It implements the (undocumented) ActiveEvent interface in order to become
 * "self dispatchable"
 */
class AWTRequest extends AWTEvent implements ActiveEvent {

	Request fRequest= null;

	public AWTRequest(Request r) {
		super(r, RESERVED_ID_MAX+4711);
		fRequest= r;
	}
	public void dispatch() {
		Assert.isNotNull(fRequest);
		fRequest.dispatch();
	}
}
