package com.ibm.ulc.ui.dataTypes;

/**
 * Defines the interface of an object that
 * converts from String to a type of objects and vice versa.
 *
 * Creation date: (23-Nov-99 10:08:26 AM)
 * @author: Markus Marzetta
 */
public interface IStringConverter {
/**
 * Answer a String  representation of the parameter suitable for editing
 * (e.g. increased precision).
 *
 * Creation date: (23-Nov-99 10:30:23 AM)
 * @return java.lang.Object
 * @param object java.lang.Object
 */
String convertToEditString(Object object);
/**
 * Answer an object described by the String parameter.
 *
 * Creation date: (23-Nov-99 10:19:45 AM)
 * @return java.lang.Object
 * @param string java.lang.String
 * @exception com.ibm.ulc.ui.dataTypes.DataTypeConversionException The exception description.
 */
Object convertToObject(String string) throws DataTypeConversionException;
/**
 * Answer a String  representation of the parameter.
 *
 * Creation date: (23-Nov-99 10:30:23 AM)
 * @return java.lang.Object
 * @param object java.lang.Object
 */
String convertToString(Object object);
}
